"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.regex = void 0;
const invalid_1 = __importDefault(require("./invalid"));
exports.regex = re => input => {
    if (re.flags.includes('g')) {
        throw new TypeError(`Expected regex without g flag ${String(re)}.`);
    }
    const r = input.match(re);
    if (!r) {
        throw new invalid_1.default(input);
    }
    return [input.slice(r[0].length), r];
};
exports.default = exports.regex;
